﻿
<div id="dd">
    @{

        var props = Model.GetType().GetProperties();

        foreach (System.Reflection.PropertyInfo prop in props)
        {

            Test.Filters.ViewFilter viewFilter = prop.GetCustomAttributes(false).FirstOrDefault(x => x.GetType().Equals(typeof(Test.Filters.ViewFilter))) as Test.Filters.ViewFilter;
            if (viewFilter != null && viewFilter.ShowInView)
            {

                var displayInfo = prop.GetCustomAttributes(false).FirstOrDefault(x => x.GetType().Equals(typeof(System.ComponentModel.DataAnnotations.DisplayAttribute))) as System.ComponentModel.DataAnnotations.DisplayAttribute;
                <label>@displayInfo.Name </label><br />



                switch (prop.PropertyType.Name)
                {
                    case "String":
                        <input type="text" name="@prop.Name" /><br />
                        break;
                    case "DateTime":
                        <input type="date" name="@prop.Name" />
                        break;
                }


            }



        }


    }
</div><br />
<button id="@("Save"+Model.GetType().Name)">Save </button>
<hr />
<ul id="list">
</ul>

<hr />
<ul id="details">

</ul>

<script>

    $(document).ready(function () {
        $('#@("Save"+Model.GetType().Name)').click(function () {
            debugger
            var data = {};
            $('#dd').find('input').each((n, e) => {
                data[e.name] = e.value;
            });
            $.ajax({
                type: "POST",
                url: "@("api/"+Model.GetType().Name)",
                data: JSON.stringify(data),
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (data) {
                    if (data){
                    alert('saved');
                }
                },
                failure: function (errMsg) {
                    alert(errMsg);
                }
            });
        });
    loadAll();
    });
    function showDetails(id) {
         $.ajax({
                type: "GET",
                url: "@("api/"+Model.GetType().Name)/"+id,
                dataType: "json",
             success: function (data) {
                 $('#details').empty();
                 Object.keys(data).forEach(x => {

                     $('#details').append('<li>' + x + ' : ' + data[x] + '</li>');
                 });
             },
                failure: function (errMsg) {
                    alert(errMsg);
                }
            });
    }
    function loadAll() {
         $.ajax({
                type: "GET",
                url: "@("api/"+Model.GetType().Name)",
                dataType: "json",
             success: function (data) {
                 $('#list').empty();
                 data.forEach(x=> {
                     @if (Model.GetType() == typeof(Test.Storage.Person))
                     {
                        @Html.Raw("$('#list').append('<li onclick=\"showDetails('+x.id+')\">'+x.firstName+'</li>');");
                     }
                     else
                     {
                        @Html.Raw("$('#list').append('<li onclick=\"showDetails('+x.id+')\">'+x.title+'</li>');");
                     }

                 });
             },
                failure: function (errMsg) {
                    alert(errMsg);
                }
            });

    }
</script>